# Contributing Guide

### [dart_dev](https://github.com/Workiva/dart_dev)
- This repo uses [dart_dev](https://github.com/Workiva/dart_dev) for the majority of tasks (formatting, analyze, running tests etc). You may want to read the documention on it for a better understanding.

### Formatting, analysis, tests and coverage
- CI enforces dart format, runs the analyzer and requires that all tests pass (along with a few other tasks).
- Although the analyzer will not fail on all lints, hints etc, please try to avoid adding any without good reason. You may use ignore comments so long as there is a good reason to ignore the lint.
- Tests are the best, please add them :)
- Coverage is reported on all PRs. 100% coverage is not required, but its a good goal to strive towards. Missing coverage should be justified on the PR as to why those lines are not covered.

### Best Practices
- Please use good, descriptive commit messages, PR titles and PR descriptions.
- Please document all public API members. Documentation on private code is highly recommended.
- You are welcome to open PRs before they are ready for review, but please indicate that on the PR (ideally in the title).
- Please do not modify branch history once reviewers had made a pass over the code. Rewriting history makes it harder to follow changes that are introduced.
  - Before the PR is "open to review" feel free to rebase and rewrite your branch history to the ends of days!